if (!window.move) window.move = function() {
  if (typeof window.global === "undefined") window.global = window;
  var Require = function Require(parentExports) {
    function normalizeArray(parts) {
      var up = 0;
      for (var i = parts.length; i >= 0; i--) {
        var last = parts[i];
        if (last == ".") {
          parts.splice(i, 1);
        } else if (last === "..") {
          parts.splice(i, 1);
          up++;
        } else if (up) {
          parts.splice(i, 1);
          up--;
        }
      }
      return parts;
    }
    function normalizeId(id, parentId) {
      id = id.replace(/\/+$/g, "");
      var components = (parentId ? parentId + "/../" + id : id).split("/");
      return normalizeArray(components).join("/");
    }
    function normalizeUrl(url, baseLocation) {
      if (!/^\w+:/.test(url)) {
        var u = baseLocation.protocol + "//" + baseLocation.hostname;
        if (baseLocation.port && baseLocation.port !== 80) {
          u += ":" + baseLocation.port;
        }
        var path = baseLocation.pathname;
        if (url.charAt(0) === "/") {
          url = u + normalizeArray(url.split("/")).join("/");
        } else {
          path += (path.charAt(path.length - 1) === "/" ? "" : "/../") + url;
          url = u + normalizeArray(path.split("/")).join("/");
        }
      }
      return url;
    }
    var defineConstant;
    if (Object.defineProperty) {
      defineConstant = function(obj, name, value) {
        Object.defineProperty(obj, name, {
          value: value,
          writable: false,
          enumerable: true,
          configurable: false
        });
      };
    } else {
      defineConstant = function(obj, name, value) {
        obj[name] = value;
      };
    }
    function require(id, parentId, parentURI) {
      var originalInputId = id;
      if (id.charAt(0) === ".") {
        if (parentURI && parentURI.indexOf(parentId + "/index") !== -1) parentId += "/index";
        var id1 = id;
        id = normalizeId(id, parentId);
      }
      if (!require.modules.hasOwnProperty(id)) {
        throw new Error("Module not found " + JSON.stringify(originalInputId));
      }
      var mod = require.modules[id];
      if (mod.exports === undefined) {
        var _require = function(_id) {
          return require(_id, id, mod.uri);
        };
        defineConstant(_require, "main", require.main);
        var block = mod.block;
        delete mod.block;
        mod.exports = {};
        if (require.initFilter) {
          block = require.initFilter(block);
        }
        block(_require, mod, mod.exports);
      }
      return mod.exports;
    }
    function define(id, uri, block) {
      if (typeof uri === "function") {
        block = uri;
        uri = null;
      }
      var mod = {
        block: block
      };
      defineConstant(mod, "id", String(id));
      if (uri) {
        defineConstant(mod, "uri", String(uri));
      }
      require.modules[mod.id] = mod;
      return mod;
    }
    require.modules = {};
    var mainModule = define("");
    delete mainModule.block;
    mainModule.exports = parentExports || {};
    defineConstant(require, "main", mainModule);
    require.define = define;
    return require;
  };
  var module, modules = {};
  var _require = Require();
  _require.define("runtime/es5_array", "runtime/es5_array.js", function(require, module, exports, __filename, __dirname) {
    if (!Array.isArray) Array.isArray = function isArray(obj) {
      return obj instanceof Array || Object.prototype.toString.call(obj) === "[object Array]";
    };
    if (!Array.prototype.indexOf) Array.prototype.indexOf = function indexOf(value, begin) {
      var i, L = this.length;
      for (i = +begin || 0; i < L; ++i) {
        if (this[i] === value) return i;
      }
      return -1;
    };
    if (!Array.prototype.lastIndexOf) Array.prototype.lastIndexOf = function lastIndexOf(value, begin) {
      var i = Math.min(this.length, +begin || 0);
      for (; i !== -1; --i) {
        if (this[i] === value) return i;
      }
      return -1;
    };
    if (!Array.prototype.filter) Array.prototype.filter = function filter(block, ctx) {
      var values = [];
      for (var i = 0; i < this.length; i++) {
        if (block.call(ctx, this[i])) {
          values.push(this[i]);
        }
      }
      return values;
    };
    if (!Array.prototype.forEach) Array.prototype.forEach = function forEach(block, ctx) {
      var len = this.length >>> 0;
      for (var i = 0; i < len; ++i) {
        if (i in this) {
          block.call(ctx, this[i], i, this);
        }
      }
    };
    if (!Array.prototype.every) Array.prototype.every = function every(block, ctx) {
      var len = this.length >>> 0;
      for (var i = 0; i < len; ++i) {
        if (i in this && !block.call(ctx, this[i], i, this)) return false;
      }
      return true;
    };
    if (!Array.prototype.some) Array.prototype.some = function some(block, ctx) {
      var len = this.length >>> 0;
      for (var i = 0; i < len; ++i) {
        if (i in this && block.call(ctx, this[i], i, this)) return true;
      }
      return false;
    };
    if (!Array.prototype.map) Array.prototype.map = function map(fun, ctx) {
      var len = this.length >>> 0, res = new Array(len);
      for (var i = 0; i < len; ++i) {
        res[i] = fun.call(ctx, this[i], i, this);
      }
      return res;
    };
    if (!Array.prototype.reduce) Array.prototype.reduce = function reduce(fun) {
      var len = this.length >>> 0, i = 0, rv;
      if (len === 0 && arguments.length === 1) throw new TypeError;
      if (arguments.length >= 2) {
        rv = arguments[1];
      } else {
        do {
          if (i in this) {
            rv = this[i++];
            break;
          }
          if (++i >= len) throw new TypeError;
        } while (true);
      }
      for (; i < len; i++) {
        if (i in this) {
          rv = fun.call(null, rv, this[i], i, this);
        }
      }
      return rv;
    };
    if (!Array.prototype.unshift) Array.prototype.unshift = function() {
      this.reverse();
      var i = arguments.length;
      while (i--) this.push(arguments[i]);
      this.reverse();
      return this.length;
    };
  });
  _require.define("runtime/es5_date", "runtime/es5_date.js", function(require, module, exports, __filename, __dirname) {
    if (!Date.now) Date.now = function now() {
      return (new Date).getTime();
    };
    if (!Date.prototype.getTimezoneOffset) Date.prototype.getTimezoneOffset = function getTimezoneOffset() {
      if (this._timezoneOffsetStd === undefined) {
        var date1 = new Date(this.getFullYear(), this.getMonth(), this.getDate(), 0, 0, 0, 0), temp = date1.toGMTString(), date2 = new Date(temp.substring(0, temp.lastIndexOf(" ") - 1));
        this._timezoneOffsetStd = (date2 - date1) / 6e4;
      }
      return this._timezoneOffsetStd;
    };
  });
  _require.define("runtime/es5_json", "runtime/es5_json.js", function(require, module, exports, __filename, __dirname) {
    var JSON = global.JSON;
    if (typeof JSON !== "object" || typeof JSON.stringify !== "function" || typeof JSON.parse !== "function") {
      JSON = global.JSON = {};
      (function() {
        "use strict";
        function f(n) {
          return n < 10 ? "0" + n : n;
        }
        if (typeof Date.prototype.toJSON !== "function") {
          Date.prototype.toJSON = function(key) {
            return isFinite(this.valueOf()) ? this.getUTCFullYear() + "-" + f(this.getUTCMonth() + 1) + "-" + f(this.getUTCDate()) + "T" + f(this.getUTCHours()) + ":" + f(this.getUTCMinutes()) + ":" + f(this.getUTCSeconds()) + "Z" : null;
          };
          String.prototype.toJSON = Number.prototype.toJSON = Boolean.prototype.toJSON = function(key) {
            return this.valueOf();
          };
        }
        var cx = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g, escapable = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g, gap, indent, meta = {
          "\b": "\\b",
          "\t": "\\t",
          "\n": "\\n",
          "\f": "\\f",
          "\r": "\\r",
          '"': '\\"',
          "\\": "\\\\"
        }, rep;
        function quote(string) {
          escapable.lastIndex = 0;
          return escapable.test(string) ? '"' + string.replace(escapable, function(a) {
            var c = meta[a];
            return typeof c === "string" ? c : "\\u" + ("0000" + a.charCodeAt(0).toString(16)).slice(-4);
          }) + '"' : '"' + string + '"';
        }
        function str(key, holder) {
          var i, k, v, length, mind = gap, partial, value = holder[key];
          if (value && typeof value === "object" && typeof value.toJSON === "function") {
            value = value.toJSON(key);
          }
          if (typeof rep === "function") {
            value = rep.call(holder, key, value);
          }
          switch (typeof value) {
           case "string":
            return quote(value);
           case "number":
            return isFinite(value) ? String(value) : "null";
           case "boolean":
           case "null":
            return String(value);
           case "object":
            if (!value) {
              return "null";
            }
            gap += indent;
            partial = [];
            if (Object.prototype.toString.apply(value) === "[object Array]") {
              length = value.length;
              for (i = 0; i < length; i += 1) {
                partial[i] = str(i, value) || "null";
              }
              v = partial.length === 0 ? "[]" : gap ? "[\n" + gap + partial.join(",\n" + gap) + "\n" + mind + "]" : "[" + partial.join(",") + "]";
              gap = mind;
              return v;
            }
            if (rep && typeof rep === "object") {
              length = rep.length;
              for (i = 0; i < length; i += 1) {
                k = rep[i];
                if (typeof k === "string") {
                  v = str(k, value);
                  if (v) {
                    partial.push(quote(k) + (gap ? ": " : ":") + v);
                  }
                }
              }
            } else {
              for (k in value) {
                if (Object.hasOwnProperty.call(value, k)) {
                  v = str(k, value);
                  if (v) {
                    partial.push(quote(k) + (gap ? ": " : ":") + v);
                  }
                }
              }
            }
            v = partial.length === 0 ? "{}" : gap ? "{\n" + gap + partial.join(",\n" + gap) + "\n" + mind + "}" : "{" + partial.join(",") + "}";
            gap = mind;
            return v;
          }
        }
        if (typeof JSON.stringify !== "function") {
          JSON.stringify = function(value, replacer, space) {
            var i;
            gap = "";
            indent = "";
            if (typeof space === "number") {
              for (i = 0; i < space; i += 1) {
                indent += " ";
              }
            } else if (typeof space === "string") {
              indent = space;
            }
            rep = replacer;
            if (replacer && typeof replacer !== "function" && (typeof replacer !== "object" || typeof replacer.length !== "number")) {
              throw new Error("JSON.stringify");
            }
            return str("", {
              "": value
            });
          };
        }
        if (typeof JSON.parse !== "function") {
          JSON.parse = function(text, reviver) {
            var j;
            function walk(holder, key) {
              var k, v, value = holder[key];
              if (value && typeof value === "object") {
                for (k in value) {
                  if (Object.hasOwnProperty.call(value, k)) {
                    v = walk(value, k);
                    if (v !== undefined) {
                      value[k] = v;
                    } else {
                      delete value[k];
                    }
                  }
                }
              }
              return reviver.call(holder, key, value);
            }
            text = String(text);
            cx.lastIndex = 0;
            if (cx.test(text)) {
              text = text.replace(cx, function(a) {
                return "\\u" + ("0000" + a.charCodeAt(0).toString(16)).slice(-4);
              });
            }
            if (/^[\],:{}\s]*$/.test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g, "@").replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, "]").replace(/(?:^|:|,)(?:\s*\[)+/g, ""))) {
              j = eval("(" + text + ")");
              return typeof reviver === "function" ? walk({
                "": j
              }, "") : j;
            }
            throw new SyntaxError("JSON.parse");
          };
        }
      })();
    }
  });
  _require.define("runtime/es5_object", "runtime/es5_object.js", function(require, module, exports, __filename, __dirname) {
    var slice = Array.prototype.slice.call;
    if (!Object.create) Object.create = function create(proto, props) {
      var Ctor = function Ctor() {
        if (props && Object.defineProperties) Object.defineProperties(this, props);
      };
      Ctor.prototype = proto;
      return new Ctor;
    };
    if (!Object.keys) Object.keys = function keys(obj) {
      var keys = [];
      for (var k in obj) keys.push(k);
      return keys;
    };
    if (!Object.getOwnPropertyNames) Object.getOwnPropertyNames = function getOwnPropertyNames() {
      return Object.keys.apply(this, slice(arguments));
    };
    if (!Object.getOwnPropertyDescriptor) Object.getOwnPropertyDescriptor = function getOwnPropertyDescriptor(obj, prop) {
      if (obj.hasOwnProperty(prop)) {
        return {
          configurable: true,
          enumerable: true,
          value: obj[prop],
          writable: true
        };
      }
    };
    if (!Object.prototype.hasOwnProperty) Object.prototype.hasOwnProperty = function(k) {
      return k in this;
    };
    if (!Object.defineProperty) {
      if (Object.prototype.__defineGetter__ && Object.prototype.__defineSetter__) {
        Object.defineProperty = function(obj, prop, desc) {
          if (typeof desc === "object") {
            if (desc.hasOwnProperty("value")) {
              if (!obj.__lookupGetter__(prop) && !obj.__lookupSetter__(prop)) {
                obj[prop] = desc.value;
              }
              if (desc.hasOwnProperty("get") || desc.hasOwnProperty("set")) {
                throw new TypeError("Object doesn't support this action");
              }
            } else {
              if (typeof desc.get === "function") {
                obj.__defineGetter__(prop, desc.get);
              }
              if (typeof desc.set === "function") {
                obj.__defineSetter__(prop, desc.set);
              }
            }
          }
          return obj;
        };
      }
    }
    if (!Object.defineProperties && Object.defineProperty) Object.defineProperties = function(obj, props) {
      for (var prop in props) {
        Object.defineProperty(obj, prop, props[prop]);
      }
    };
  });
  _require.define("runtime/es5_string", "runtime/es5_string.js", function(require, module, exports, __filename, __dirname) {
    if (!String.prototype.trim) String.prototype.trim = function trim() {
      return this.replace(/^(?:\s|\u00A0)+/, "").replace(/(?:\s|\u00A0)+$/, "");
    };
    if (!String.prototype.trimLeft) String.prototype.trimLeft = function trimLeft() {
      return this.replace(/^(?:\s|\u00A0)+/, "");
    };
    if (!String.prototype.trimRight) String.prototype.trimRight = function trimRight() {
      return this.replace(/(?:\s|\u00A0)+$/, "");
    };
  });
  _require.define("runtime", "runtime/index.js", function(require, module, exports, __filename, __dirname) {
    require("./runtime_string");
    if (!global.__move) global.__move = {};
    global.__move.runtime = {
      _MoveKWArgsT: require("./symbols")._MoveKWArgsT
    };
    global.__move.runtime = require("./runtime_move");
  });
  _require.define("runtime/runtime_array", "runtime/runtime_array.js", function(require, module, exports, __filename, __dirname) {
    if (typeof Array.prototype.unique !== "function") Array.prototype.unique = function unique() {
      var a = [], i, j, l = this.length;
      for (i = 0; i < l; ++i) {
        for (j = i + 1; j < l; ++j) {
          if (this[i] === this[j]) {
            j = ++i;
          }
        }
        a.push(this[i]);
      }
      return a;
    };
    if (typeof Array.prototype._move_setSlice != "function") {
      var _splice = Array.prototype.splice;
      Array.prototype._move_setSlice = function _move_setSlice(startIndex, endIndex, value) {
        var length;
        if (endIndex !== undefined) {
          if (typeof endIndex !== "number") throw new TypeError("Second argument must be a number");
          length = endIndex - startIndex;
        } else {
          length = this.length;
        }
        return _splice.apply(this, [ startIndex, length ].concat(value));
      };
    }
  });
  _require.define("runtime/runtime_date", "runtime/runtime_date.mv", function(require, module, exports, __filename, __dirname) {
    (function() {
      "use strict";
      var Move, _MoveKWArgsT, Text, extend, create, print, repeat, after, JSON;
      Move = __move.runtime, _MoveKWArgsT = Move._MoveKWArgsT, Text = Move.Text, extend = Move.extend, create = Move.create, print = Move.print, repeat = Move.repeat, after = Move.after, JSON = Move.JSON;
      if (Date.distantFuture === undefined) Date.distantFuture = new Date(359753450957352);
      if (Date.distantPast === undefined) Date.distantPast = new Date(-621356868e5);
      if (!Date.nowUTC) Date.nowUTC = function nowUTC() {
        return (new Date).getUTCTime();
      };
      if (!Date.prototype.getUTCTime) Date.prototype.getUTCTime = function getUTCTime() {
        return this.getTime() - this.getTimezoneOffset();
      };
      if (!Date.prototype.getUTCComponents) return Date.prototype.getUTCComponents = function getUTCComponents() {
        return [ this.getUTCFullYear(), this.getUTCMonth() + 1, this.getUTCDate(), this.getUTCHours(), this.getUTCMinutes(), this.getUTCSeconds(), this.getUTCMilliseconds() ];
      };
    })();
  });
  _require.define("runtime/runtime_inspect", "runtime/runtime_inspect.js", function(require, module, exports, __filename, __dirname) {
    exports.inspect = function(obj, showHidden, depth, colors) {
      var seen = [];
      var stylize = function(str, styleType) {
        return str;
      };
      function format(value, recurseTimes) {
        if (value && typeof value.inspect === "function" && value !== exports && value.inspect !== exports.inspect && !(value.constructor && value.constructor.prototype === value)) {
          return value.inspect(recurseTimes);
        }
        switch (typeof value) {
         case "undefined":
          return stylize("undefined", "undefined");
         case "string":
          var simple = JSON.stringify(value).replace(/'/g, "\\'").replace(/\\"/g, '"').replace(/(^"|"$)/g, "'");
          return stylize(simple, "string");
         case "number":
          return stylize("" + value, "number");
         case "boolean":
          return stylize("" + value, "boolean");
        }
        if (value === null) {
          return stylize("null", "null");
        }
        var visible_keys = Object.keys(value);
        var keys = showHidden ? Object.getOwnPropertyNames(value) : visible_keys;
        if (typeof value === "function" && keys.length === 0) {
          if (isRegExp(value)) {
            return stylize("" + value, "regexp");
          } else {
            var name = value.name ? ": " + value.name : "";
            return stylize("[Function" + name + "]", "special");
          }
        }
        if (isDate(value) && keys.length === 0) {
          return stylize(value.toUTCString(), "date");
        }
        var base, type, braces;
        if (isArray(value)) {
          type = "Array";
          braces = [ "[", "]" ];
        } else {
          type = "Object";
          braces = [ "{", "}" ];
        }
        if (typeof value === "function") {
          var n = value.name ? ": " + value.name : "";
          base = isRegExp(value) ? " " + value : " [Function" + n + "]";
        } else {
          base = "";
        }
        if (isDate(value)) {
          base = " " + value.toUTCString();
        }
        if (keys.length === 0) {
          return braces[0] + base + braces[1];
        }
        if (recurseTimes < 0) {
          if (isRegExp(value)) {
            return stylize("" + value, "regexp");
          } else {
            return stylize("[Object]", "special");
          }
        }
        seen.push(value);
        var output = keys.map(function(key) {
          var name, str;
          if (value.__lookupGetter__) {
            if (value.__lookupGetter__(key)) {
              if (value.__lookupSetter__(key)) {
                str = stylize("[Getter/Setter]", "special");
              } else {
                str = stylize("[Getter]", "special");
              }
            } else {
              if (value.__lookupSetter__(key)) {
                str = stylize("[Setter]", "special");
              }
            }
          }
          if (visible_keys.indexOf(key) < 0) {
            name = "[" + key + "]";
          }
          if (!str) {
            if (seen.indexOf(value[key]) < 0) {
              if (recurseTimes === null) {
                str = format(value[key]);
              } else {
                str = format(value[key], recurseTimes - 1);
              }
              if (str.indexOf("\n") > -1) {
                if (isArray(value)) {
                  str = str.split("\n").map(function(line) {
                    return "  " + line;
                  }).join("\n").substr(2);
                } else {
                  str = "\n" + str.split("\n").map(function(line) {
                    return "   " + line;
                  }).join("\n");
                }
              }
            } else {
              str = stylize("[Circular]", "special");
            }
          }
          if (typeof name === "undefined") {
            if (type === "Array" && key.match(/^\d+$/)) {
              return str;
            }
            name = JSON.stringify("" + key);
            if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
              name = name.substr(1, name.length - 2);
              name = stylize(name, "name");
            } else {
              name = name.replace(/'/g, "\\'").replace(/\\"/g, '"').replace(/(^"|"$)/g, "'");
              name = stylize(name, "string");
            }
          }
          return name + ": " + str;
        });
        seen.pop();
        var numLinesEst = 0;
        var length = output.reduce(function(prev, cur) {
          numLinesEst++;
          if (cur.indexOf("\n") >= 0) numLinesEst++;
          return prev + cur.length + 1;
        }, 0);
        if (length > 50) {
          output = braces[0] + (base === "" ? "" : base + "\n ") + " " + output.join(",\n  ") + " " + braces[1];
        } else {
          output = braces[0] + base + " " + output.join(", ") + " " + braces[1];
        }
        return output;
      }
      return format(obj, typeof depth === "undefined" ? 2 : depth);
    };
    function isArray(ar) {
      return ar instanceof Array || Array.isArray(ar) || ar && ar !== Object.prototype && isArray(ar.prototype);
    }
    function isRegExp(re) {
      var s = "" + re;
      return re instanceof RegExp || typeof re === "function" && re.constructor.name === "RegExp" && re.compile && re.test && re.exec && s.match(/^\/.*\/[gim]{0,3}$/);
    }
    function isDate(d) {
      if (d instanceof Date) return true;
      if (typeof d !== "object") return false;
      var properties = Date.prototype && Object.getOwnPropertyNames(Date.prototype);
      var proto = d.__proto__ && Object.getOwnPropertyNames(d.__proto__);
      return JSON.stringify(proto) === JSON.stringify(properties);
    }
  });
  _require.define("runtime/runtime_move", "runtime/runtime_move.mv", function(require, module, exports, __filename, __dirname) {
    (function() {
      "use strict";
      var Move, _MoveKWArgsT, Text, extend, create, print, repeat, after, JSON, IS_KNOWN_ES5_HOST, defineConstant, extend, create, repeat, after, _JSON, wrapEventEmitter, events;
      Move = __move.runtime, _MoveKWArgsT = Move._MoveKWArgsT, Text = Move.Text, extend = Move.extend, create = Move.create, print = Move.print, repeat = Move.repeat, after = Move.after, JSON = Move.JSON;
      _MoveKWArgsT = global.__move.runtime._MoveKWArgsT;
      global.__move.runtime = exports;
      IS_KNOWN_ES5_HOST = !!(typeof process !== "undefined" && (typeof process.versions === "object" && process.versions.node || process.pid));
      if (!IS_KNOWN_ES5_HOST) {
        require("./es5_object");
        require("./es5_array");
        require("./es5_date");
        require("./es5_json");
      }
      require("./runtime_object");
      require("./runtime_string");
      require("./runtime_date");
      require("./runtime_array");
      if (Object.defineProperty) {
        defineConstant = function defineConstant(obj, name, value) {
          obj !== null && typeof obj === "object" && obj.__kw === _MoveKWArgsT && (arguments.keywords = obj, value = obj.value, name = obj.name, obj = obj.obj);
          return Object.defineProperty(obj, name, {
            value: value,
            writable: false,
            enumerable: true,
            configurable: false
          });
        };
      } else {
        defineConstant = function defineConstant(obj, name, value) {
          obj !== null && typeof obj === "object" && obj.__kw === _MoveKWArgsT && (arguments.keywords = obj, value = obj.value, name = obj.name, obj = obj.obj);
          return obj[name] = value;
        };
      }
      defineConstant(exports, "_MoveKWArgsT", _MoveKWArgsT);
      defineConstant(exports, "Text", String);
      String.prototype.toText = String.prototype.toString;
      exports.extend = extend = function extend(object, body) {
        object !== null && typeof object === "object" && object.__kw === _MoveKWArgsT && (arguments.keywords = object, body = object.body, object = object.object);
        var T;
        T = body === null ? "undefined" : typeof body;
        if (T === "object") Object.keys(body).forEach(function(key) {
          key !== null && typeof key === "object" && key.__kw === _MoveKWArgsT && (arguments.keywords = key, key = key.key);
          return object[key] = body[key];
        }); else if (T === "function") body.call(object); else if (T !== "undefined") throw new TypeError('"body" argument must be either an object or a function, not a ' + T);
        return object;
      };
      exports.create = create = function create(prototype, body) {
        prototype !== null && typeof prototype === "object" && prototype.__kw === _MoveKWArgsT && (arguments.keywords = prototype, body = prototype.body, prototype = prototype.prototype);
        return extend(Object.create(prototype), body);
      };
      if (typeof Object.inspect !== "function") {
        try {
          Object.inspect = require("util").inspect;
          if (typeof Object.inspect !== "function") throw 1;
        } catch (e) {
          Object.inspect = require("./runtime_inspect").inspect;
        }
      }
      if (typeof console !== "undefined" && console.log) {
        if (typeof window !== "undefined") {
          exports.print = function print() {
            return print.consoleFun.apply(console, Array.prototype.slice.call(arguments));
          };
          exports.print.consoleFun = console.log;
        } else {
          exports.print = console.log;
        }
      } else {
        exports.print = function print() {};
      }
      exports.repeat = repeat = function repeat(times, every, block) {
        times !== null && typeof times === "object" && times.__kw === _MoveKWArgsT && (arguments.keywords = times, block = times.block, every = times.every, times = times.times);
        var i, timer;
        if (typeof times === "function") {
          while (true) if (!times()) break;
          return;
        }
        if (typeof block === "function") {
          if (times !== undefined) {
            for (i = 0; i < times; ++i) if (block(i) === true) break;
          } else if (every !== undefined) {
            timer = Object.create({}, {
              cancel: {
                value: function() {
                  return clearInterval(this.id);
                }
              }
            });
            timer.id = setInterval(function() {
              return block(timer);
            }, every);
            return timer;
          } else {
            while (true) if (!block()) break;
          }
        } else {
          return function(block) {
            block !== null && typeof block === "object" && block.__kw === _MoveKWArgsT && (arguments.keywords = block, block = block.block);
            if (times !== undefined) {
              for (i = 0; i < times; ++i) if (block(i) === true) break;
            } else if (every !== undefined) {
              timer = Object.create({}, {
                cancel: {
                  value: function() {
                    return clearInterval(this.id);
                  }
                }
              });
              timer.id = setInterval(function() {
                return block(timer);
              }, every);
              return timer;
            } else {
              while (true) if (!block()) break;
            }
          };
        }
      };
      exports.after = after = function after(delay, date) {
        delay !== null && typeof delay === "object" && delay.__kw === _MoveKWArgsT && (arguments.keywords = delay, date = delay.date, delay = delay.delay);
        if (delay) {
          if (typeof delay !== "number") throw new TypeError('"delay" argument must be a number');
        } else if (date) {
          if (typeof date === "string" || typeof date === "number") {
            date = new Date(date);
            if (isNaN(date.getTime())) throw new Error('Invalid date/time passed for "date" argument');
          } else if (typeof date !== "object" || !(date instanceof Date)) {
            throw new TypeError('"date" argument must be a Date object or a string');
          }
          delay = Math.max(0, date.getTime() - (new Date).getTime());
        }
        return function(block) {
          block !== null && typeof block === "object" && block.__kw === _MoveKWArgsT && (arguments.keywords = block, block = block.block);
          return setTimeout(block, delay);
        };
      };
      JSON = global.JSON;
      _JSON = function _JSON(build, parse) {
        build !== null && typeof build === "object" && build.__kw === _MoveKWArgsT && (arguments.keywords = build, parse = build.parse, build = build.build);
        if (build !== undefined) return JSON.stringify(build); else if (parse !== undefined) return JSON.parse(parse); else throw new TypeError('Expected either "parse" or "build" argument');
      };
      _JSON.parse = JSON.parse;
      _JSON.stringify = JSON.stringify;
      exports.JSON = _JSON;
      wrapEventEmitter = function wrapEventEmitter(target, propertyName) {
        target !== null && typeof target === "object" && target.__kw === _MoveKWArgsT && (arguments.keywords = target, propertyName = target.propertyName, target = target.target);
        var _orig, addListener;
        _orig = target[propertyName];
        addListener = function addListener(event, call) {
          event !== null && typeof event === "object" && event.__kw === _MoveKWArgsT && (arguments.keywords = event, call = event.call, event = event.event);
          var self;
          if (call) {
            return _orig.call(this, event, call);
          } else {
            self = this;
            return function(block) {
              block !== null && typeof block === "object" && block.__kw === _MoveKWArgsT && (arguments.keywords = block, block = block.block);
              return _orig.call(self, event, block);
            };
          }
        };
        return target[propertyName] = addListener;
      };
      try {
        events = require("events");
      } catch (e) {}
      if (events && events.EventEmitter) {
        wrapEventEmitter(events.EventEmitter.prototype, "addListener");
        events.EventEmitter.prototype.on = events.EventEmitter.prototype.addListener;
      }
      if (typeof process !== "undefined" && typeof process.on === "function") return wrapEventEmitter(process, "on");
    })();
  });
  _require.define("runtime/runtime_object", "runtime/runtime_object.js", function(require, module, exports, __filename, __dirname) {
    if (!Object.prototype.forEach) {
      var forEach = function forEach(block, ctx) {
        if (ctx !== null && typeof ctx !== "object") ctx = this;
        var obj = this;
        Object.keys(this).forEach(function(key) {
          block.call(ctx, key, obj[key], obj);
        });
        return this;
      };
      if (Object.defineProperty) {
        Object.defineProperty(Object.prototype, "forEach", {
          value: forEach
        });
      } else {}
    }
  });
  _require.define("runtime/runtime_string", "runtime/runtime_string.js", function(require, module, exports, __filename, __dirname) {
    if (!String.prototype.repeat) String.prototype.repeat = function repeat(times) {
      s = "";
      while (times--) s += this;
      return s;
    };
    if (!String.prototype.padLeft) String.prototype.padLeft = function padLeft(length, padstr) {
      if (this.length >= length) return this;
      return String(padstr || " ").repeat(length - this.length) + this;
    };
    if (!String.prototype.padRight) String.prototype.padRight = function padRight(length, padstr) {
      if (this.length >= length) return this;
      return this + String(padstr || " ").repeat(length - this.length);
    };
    if (!String.prototype.editDistance) String.prototype.editDistance = function editDistance(otherString) {
      var s, l = (s = this.split("")).length, t = (otherString = otherString.split("")).length, i, j, m, n;
      if (!(l || t)) return Math.max(l, t);
      for (var a = [], i = l + 1; i; a[--i] = [ i ]) ;
      for (i = t + 1; a[0][--i] = i; ) ;
      for (i = -1, m = s.length; ++i < m; ) {
        for (j = -1, n = otherString.length; ++j < n; ) {
          a[(i *= 1) + 1][(j *= 1) + 1] = Math.min(a[i][j + 1] + 1, a[i + 1][j] + 1, a[i][j] + (s[i] != otherString[j]));
        }
      }
      return a[l][t];
    };
    if (!String.prototype.matchAll) String.prototype.matchAll = function matchAll(pattern) {
      "use strict";
      if (!(pattern instanceof RegExp)) {
        pattern = new RegExp(pattern, "g");
      } else if (!pattern.global) {
        pattern = new RegExp(pattern.source, "g");
      }
      var match, matches = [];
      while (match = pattern.exec(this)) {
        matches.push(match);
      }
      return matches;
    };
    if (!String.prototype.forEachMatch) String.prototype.forEachMatch = function forEachMatch(pattern, iterfun, thisObject) {
      "use strict";
      if (!thisObject) thisObject = this;
      this.matchAll(pattern).forEach(iterfun, thisObject);
      return thisObject;
    };
    if (typeof String.prototype.toLocaleLowerCase === "function") String.prototype.toLowerCase = String.prototype.toLocaleLowerCase;
    if (typeof String.prototype.toLocaleUpperCase === "function") String.prototype.toUpperCase = String.prototype.toLocaleUpperCase;
  });
  _require.define("runtime/symbols", "runtime/symbols.js", function(require, module, exports, __filename, __dirname) {
    exports._MoveKWArgsT = function _MoveKWArgsT(obj) {
      obj.__kw = _MoveKWArgsT;
      return obj;
    };
  });
  _require("runtime");
  var move = global.__move;
  move.version = function() {
    return "0.3.2";
  };
  move.require = Require();
  return move;
}();
__move.require.define("foo","foo.mv",function(require,module,exports){
  var Move, _MoveKWArgsT, Text, extend, create, print, repeat, after, JSON, EHTML, bar;
  Move = __move.runtime, _MoveKWArgsT = Move._MoveKWArgsT, Text = Move.Text, extend = Move.extend, create = Move.create, print = Move.print, repeat = Move.repeat, after = Move.after, JSON = Move.JSON;
  EHTML = __move.EHTML;
  exports.bar = bar = function bar(name) {
    name !== null && typeof name === "object" && name.__kw === _MoveKWArgsT && (arguments.keywords = name, name = name.name);
    if (name === undefined) name = "John";
    return "This is bar, with my friend " + name;
  };
});
__move.require.define("","index.mv",function(require,module,exports){
  var Move, _MoveKWArgsT, Text, extend, create, print, repeat, after, JSON, EHTML, foo;
  Move = __move.runtime, _MoveKWArgsT = Move._MoveKWArgsT, Text = Move.Text, extend = Move.extend, create = Move.create, print = Move.print, repeat = Move.repeat, after = Move.after, JSON = Move.JSON;
  EHTML = __move.EHTML;
  foo = require("foo");
  print("foo ->", foo);
  print("foo.bar() ->", foo.bar());
  return print('foo.bar "Rob" ->', foo.bar("Rob"));
});__move.require("");